import { BuiltInControlValueAccessor, ControlValueAccessor } from './control_value_accessor';
import * as i0 from "@angular/core";
export declare const PICKER_VIEW_VALUE_ACCESSOR: any;
/**
 * @description
 * The `ControlValueAccessor` for writing a number value and listening to number input changes.
 * The value accessor is used by the `FormControlDirective`, `FormControlName`, and `NgModel`
 * directives.
 *
 * @usageNotes
 *
 * ### Using a number input with a reactive form.
 *
 * The following example shows how to use a number input with a reactive form.
 *
 * ```ts
 * const totalCountControl = new FormControl();
 * ```
 *
 * ```
 * <input type="number" [formControl]="totalCountControl">
 * ```
 *
 * @ngModule ReactiveFormsModule
 * @ngModule FormsModule
 * @publicApi
 */
export declare class PickerViewValueAccessor extends BuiltInControlValueAccessor implements ControlValueAccessor {
    value: number[] | undefined;
    /**
     * Sets the "value" property on the input element.
     * @nodoc
     */
    writeValue(value: number[]): void;
    setDisabledState(): void;
    valueChange(value: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<PickerViewValueAccessor, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<PickerViewValueAccessor, "picker-view[formControlName],picker-view[formControl],picker-view[ngModel]", never, {}, {}, never, never, false, never>;
}



declare const PickerViewValueAccessor_Listeners:["bindchange"];
declare const PickerViewValueAccessor_Properties:["value"];